import BingoGame from '@/js/lib/BingoGame.ts';
import {
	plainToInstance, instanceToPlain
} from 'class-transformer';

export default class Parser {
	// add_children(game: BingoGame, children: (BingoGoal | BingoGroup)[]): void {
	// 	for (const child of children) {
	// 		if (child instanceof BingoGroup) {
	// 			const group = new BingoGroup(child.name);
	// 			game.addGroup(group);

	// 			this.add_children(game, child.children);
	// 		}

	// 		if (child instanceof BingoGoal) {
	// 			this.add_children(child, child.children);
	// 		}
	// 	}
	// }

	// parse_new(input: BingoGame[]) {
	// 	const games: Map<string, BingoGame> = new Map;

	// 	for (const j_game of input) {
	// 		const game = new BingoGame(
	// 			j_game.id,
	// 			j_game.name,
	// 			j_game.short_description,
	// 			j_game.description
	// 		);

	// 		for (const j_group of j_game.groups) {
	// 			this.add_children(j_group)
	// 			const group = new BingoGroup(j_group.name);
	// 			game.addGroup(group);

	// 			const children = this.get_children(j_group.children);
	// 			for (const child of children) {
	// 				if (child instanceof BingoGoal) {
	// 					const goal = new BingoGoal(child.name, group);
	// 					goal.possible_spaces = child.possible_spaces;
	// 					goal.tags = child.tags;
	// 				}
	// 			}
	// 		}

	// 		const group_map: Map<string, BingoGroup> = new Map;
	// 		const group_to_group_map: Map<BingoGroup, string> = new Map;
	// 		for (const j_group of j_game.groups) {
	// 			const group = new BingoGroup(j_group.name);
	// 			if (j_group.parent_id)
	// 				group_to_group_map.set(group, j_group.parent_id);

	// 			group_map.set(j_group.name, group);
	// 			game.addGroup(group);
	// 		}

	// 		for (const [
	// 			group,
	// 			parent_id
	// 		] of group_to_group_map) {
	// 			const parent = group_map.get(parent_id);
	// 			if (!parent)
	// 				continue;

	// 			group.parent = parent;
	// 		}

	// 		for (const j_goal of j_game.goals) {
	// 			const group = group_map.get(j_goal.group_id);
	// 			if (!group)
	// 				continue;

	// 			const goal = new BingoGoal(j_goal.name, group);
	// 			goal.possible_spaces = j_goal.possible_spaces;
	// 			goal.tags = j_goal.tags;

	// 			game.addGoal(goal);
	// 		}

	// 		games.set(game.id, game);
	// 	}
	// }

	static try_parse_neat(input: string): BingoGame {
		const json: JSON = JSON.parse(input);
		const game = plainToInstance(BingoGame, json);

		return game;
	}

	static instance_to_plain(input: BingoGame): Record<string, any> {
		const json = instanceToPlain(input);

		return json;
	}
}
